pro sort_field_lines
  fields = read_csv('Field_Line_Map_ephemeris.csv', header = header)
  
  ;remove points where field line is lt 40 degrees co-latitude and gt 140 degrees co-latitude
  good_ind = where((fields.field3 gt 40) and (fields.field3 lt 140))
  flag = fields.field1[good_ind]
  r = fields.field2[good_ind]
  theta = fields.field3[good_ind]
  phi = fields.field4[good_ind]
  rhos = r*sin(theta*!pi/180.)
  ones = where(flag eq 1, /null)
  duplicated_flag = flag

;sort each section(single field line) by theta value
  for i= 0 , n_elements(ones) -2 do begin
     sorted_array = ones[i]+ sort(theta[ones[i]:(ones[i+1]-1)])
     r[ones[i]:(ones[i+1]-1)] = r[sorted_array]
     phi[ones[i]:(ones[i+1]-1)] = phi[sorted_array]
     rhos[ones[i]:(ones[i+1]-1)] = rhos[sorted_array]
     duplicated_flag[ones[i]:(ones[i+1]-1)] = duplicated_flag[sorted_array]
     theta[ones[i]:(ones[i+1]-1)] = theta[sorted_array]
  endfor
  ;do the last section
  r[ones[-1]:-1] = r[ones[-1]+sort(theta[ones[-1]:-1])]
  phi[ones[-1]:-1] = phi[ones[-1]+sort(theta[ones[-1]:-1])]
  rhos[ones[-1]:-1] = rhos[ones[-1]+sort(theta[ones[-1]:-1])]
  duplicated_flag[ones[-1]:-1] = duplicated_flag[ones[-1]+sort(theta[ones[-1]:-1])]
  theta[ones[-1]:-1] = theta[ones[-1]+sort(theta[ones[-1]:-1])]
;add flags for where ceq(2) and if ceq equals the start location(never should if in order by theta) then ceq/start(3)
 for i= 0 , n_elements(ones) -2 do begin
    max_rhos = [ones[i] + where(rhos[ones[i]:ones[i+1]-1] eq max(rhos[ones[i]:ones[i+1]-1]))]
    flag[max_rhos[0]] = 2
  endfor
  max_rhos_2 = [ones[-1] + where(rhos[ones[-1]:-1] eq max(rhos[ones[-1]:-1]))]
  flag[max_rhos_2[0]] = 2
  
  conflict=  where((duplicated_flag eq 1) and (flag eq 2), /null)
  flag[where(duplicated_flag eq 1, /null)] = 3
  flag[conflict] = 4

  a = transpose([[flag], [r], [theta], [phi], [rhos]])

  write_csv, 'New_ephemeris_Field_Line_Map.csv', a, header = ['flag','radius', 'theta', 'phi', 'rhos']
end